---
title: CanvasRenderingContext2D.transform()
slug: Web/API/CanvasRenderingContext2D/transform
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.transform()</code></strong> method of the Canvas 2D API multiplies the current transformation with the matrix described by the arguments of this method. This lets you scale, rotate, translate (move), and skew the context.</p>

<div class="notecard note">
<p><strong>Note:</strong> See also the {{domxref("CanvasRenderingContext2D.setTransform()", "setTransform()")}} method, which resets the current transform to the identity matrix and then invokes <code>transform()</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var><em>ctx</em>.transform(a, b, c, d, e, f);</var>
</pre>

<p>The transformation matrix is described by: <math><semantics><mrow><mo>[</mo><mtable columnalign="center center center" rowspacing="0.5ex"><mtr><mtd><mi>a</mi></mtd><mtd><mi>c</mi></mtd><mtd><mi>e</mi></mtd></mtr><mtr><mtd><mi>b</mi></mtd><mtd><mi>d</mi></mtd><mtd><mi>f</mi></mtd></mtr><mtr><mtd><mn>0</mn></mtd><mtd><mn>0</mn></mtd><mtd><mn>1</mn></mtd></mtr></mtable><mo>]</mo></mrow><annotation encoding="TeX">\left[ \begin{array}{ccc} a &amp; c &amp; e \\ b &amp; d &amp; f \\ 0 &amp; 0 &amp; 1 \end{array} \right]</annotation></semantics></math></p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>a</code> (m11)</dt>
 <dd>Horizontal scaling. A value of <code>1</code> results in no scaling.</dd>
 <dt><code>b</code> (m12)</dt>
 <dd>Vertical skewing.</dd>
 <dt><code>c</code> (m21)</dt>
 <dd>Horizontal skewing.</dd>
 <dt><code>d</code> (m22)</dt>
 <dd>Vertical scaling. A value of <code>1</code> results in no scaling.</dd>
 <dt><code>e</code> (dx)</dt>
 <dd>Horizontal translation (moving).</dd>
 <dt><code>f</code> (dy)</dt>
 <dd>Vertical translation (moving).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Skewing_a_shape">Skewing a shape</h3>

<p>This example skews a rectangle both vertically (<code>.2</code>) and horizontally (<code>.8</code>). Scaling and translation remain unchanged.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.transform(1, .2, .8, 1, 0, 0);
ctx.fillRect(0, 0, 100, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Skewing_a_shape', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-transform", "CanvasRenderingContext2D.transform")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.transform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.setTransform()")}}</li>
</ul>
